## nmodl 0.6

=== CMakeLists.txt ===
# =============================================================================
# Copyright (C) 2018-2022 Blue Brain Project
#
# This file is part of NMODL distributed under the terms of the GNU Lesser General Public License.
# See top-level LICENSE file for details.
# =============================================================================

cmake_minimum_required(VERSION 3.15 FATAL_ERROR)

project(NMODL LANGUAGES CXX)

# =============================================================================
# CMake common project settings
# =============================================================================
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)

# =============================================================================
# Build options for NMODL
# =============================================================================
option(NMODL_ENABLE_PYTHON_BINDINGS "Enable pybind11 based python bindings" ON)
option(NMODL_ENABLE_LEGACY_UNITS "Use original faraday, R, etc. instead of 2019 nist constants" OFF)
if(NMODL_ENABLE_LEGACY_UNITS)
  add_definitions(-DUSE_LEGACY_UNITS)
endif()
set(NMODL_EXTRA_CXX_FLAGS
    ""
    CACHE STRING "Add extra compile flags for NMODL sources")
separate_arguments(NMODL_EXTRA_CXX_FLAGS)

# =============================================================================
# Settings to enable project as submodule
# =============================================================================
set(NMODL_PROJECT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(NMODL_PROJECT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(NMODL_AS_SUBPROJECT OFF)
if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(NMODL_AS_SUBPROJECT ON)
  # output targets into top level build directory
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()

# =============================================================================
# Compile static libraries with hidden visibility
# =============================================================================
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# =============================================================================
# Find required packages
# =============================================================================
message(STATUS "CHECKING FOR FLEX/BISON")
find_package(FLEX 2.6 REQUIRED)
find_package(BISON 3.0 REQUIRED)

# =============================================================================
# Include cmake modules. Filenames ensure we always pick up NMODL's versions.
# =============================================================================
include(cmake/ClangTidyHelper.cmake)
include(cmake/CompilerHelper.cmake)
include(cmake/FlexHelper.cmake)
include(cmake/GitRevision.cmake)
include(cmake/PythonLinkHelper.cmake)
include(cmake/RpathHelper.cmake)
include(cmake/ExternalProjectHelper.cmake)

# This should apply to all NMODL targets but should not leak out when NMODL is built as a submodule.
add_compile_options(${NMODL_COMPILER_WARNING_SUPPRESSIONS})

# =============================================================================
# Set the project version now using git
# =============================================================================
project(
  NMODL
  VERSION ${NMODL_GIT_LAST_TAG}
  LANGUAGES CXX)

# =============================================================================
# HPC Coding Conventions
# =============================================================================
# initialize submodule of coding conventions under cmake
if(NOT EXISTS "${PROJECT_SOURCE_DIR}/cmake/hpc-coding-conventions/cpp/CMakeLists.txt")
  initialize_submodule("${PROJECT_SOURCE_DIR}/cmake/hpc-coding-conventions")
endif()
set(CODING_CONV_PREFIX NMODL)
add_subdirectory(cmake/hpc-coding-conventions/cpp)

# =============================================================================
# Enable sanitizer support if the NMODL_SANITIZERS variable is set
# =============================================================================
include(cmake/hpc-coding-conventions/cpp/cmake/sanitizers.cmake)
list(APPEND NMODL_EXTRA_CXX_FLAGS ${NMODL_SANITIZER_COMPILER_FLAGS})

# =============================================================================
# Initialize external libraries as submodules
# =============================================================================
set(NMODL_3RDPARTY_DIR ext)
include(cmake/hpc-coding-conventions/cpp/cmake/3rdparty.cmake)
cpp_cc_git_submodule(catch2 BUILD PACKAGE Catch2 REQUIRED)
if(NMODL_3RDPARTY_USE_CATCH2)
  # If we're using the submodule then make sure the Catch.cmake helper can be found. In newer
  # versions of Catch2, and with hpc-coding-conventions#130, this should just work...
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/ext/catch2/contrib")
endif()
include(Catch)
# If we're being built as a submodule of CoreNEURON then CoreNEURON may have already found/loaded a
# CLI11 submodule.
if(NOT TARGET CLI11::CLI11)
  cpp_cc_git_submodule(cli11 BUILD PACKAGE CLI11 REQUIRED)
endif()
# For the moment do not try and use an external Eigen.
cpp_cc_git_submodule(eigen)
cpp_cc_git_submodule(fmt BUILD PACKAGE fmt REQUIRED)
# If we're building from the submodule, make sure we pass -fPIC so that we can link the code into a
# shared library later.
if(NMODL_3RDPARTY_USE_FMT)
  set_property(TARGET fmt PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()
if(NOT NMODL_3RDPARTY_USE_FMT
   AND ((NMODL_PGI_COMPILER AND CMAKE_CXX_COMPILER_VERSION LESS_EQUAL 22.3.0)
        OR CMAKE_CXX_COMPILER_ID STREQUAL "Intel"))
  message(
    WARNING
      "fmt might generate issues with NVHPC <=22.3 and Intel compiler when installed with C++11 or later standard enabled"
  )
endif()
cpp_cc_git_submodule(json BUILD PACKAGE nlohmann_json REQUIRED)
cpp_cc_git_submodule(pybind11 BUILD PACKAGE pybind11 REQUIRED)
# Tell spdlog not to use its bundled fmt, it should either use the fmt submodule or a truly external
# installation for consistency. This line should be harmless if we use an external spdlog.
set(SPDLOG_FMT_EXTERNAL ON)
cpp_cc_git_submodule(spdlog BUILD PACKAGE spdlog REQUIRED)
if(NMODL_3RDPARTY_USE_SPDLOG)
  # See above, same logic as fmt
  set_property(TARGET spdlog PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

# =============================================================================
# Format & execute ipynb notebooks in place (pip install nbconvert clean-ipynb)
# =============================================================================
add_custom_target(
  nb-format
  jupyter
  nbconvert
  --to
  notebook
  --execute
  --inplace
  --ExecutePreprocessor.timeout=360
  "${CMAKE_SOURCE_DIR}/docs/notebooks/*.ipynb"
  &&
  clean_ipynb
  "${CMAKE_SOURCE_DIR}/docs/notebooks/*.ipynb")

# =============================================================================
# Adjust install prefix for wheel
# =============================================================================
if(NOT LINK_AGAINST_PYTHON)
  set(NMODL_INSTALL_DIR_SUFFIX "nmodl/.data/")
endif()

# =============================================================================
# Find required python packages
# =============================================================================
message(STATUS "CHECKING FOR PYTHON")
find_package(PythonInterp 3.7 REQUIRED)
include(cmake/hpc-coding-conventions/cpp/cmake/bbp-find-python-module.cmake)
cpp_cc_find_python_module(jinja2 2.9.3 REQUIRED)
cpp_cc_find_python_module(pytest 3.3.0 REQUIRED)
cpp_cc_find_python_module(sympy 1.3 REQUIRED)
cpp_cc_find_python_module(textwrap 0.9 REQUIRED)
cpp_cc_find_python_module(yaml 3.12 REQUIRED)

# =============================================================================
# Compiler specific flags for external submodules
# =============================================================================
if(NMODL_PGI_COMPILER)
  # PGI with llvm code generation doesn't have necessary assembly intrinsic headers
  add_compile_definitions(EIGEN_DONT_VECTORIZE=1)
  # nlohmann/json doesn't check for PGI compiler
  add_compile_definitions(JSON_SKIP_UNSUPPORTED_COMPILER_CHECK=1)
endif()

include_directories(${NMODL_PROJECT_SOURCE_DIR} ${NMODL_PROJECT_SOURCE_DIR}/src
                    ${PROJECT_BINARY_DIR}/src)

# generate file with version number from git and nrnunits.lib file path
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/config/config.cpp.in
               ${PROJECT_BINARY_DIR}/src/config/config.cpp @ONLY)

# generate Doxyfile with correct source paths
configure_file(${NMODL_PROJECT_SOURCE_DIR}/docs/Doxyfile.in
               ${NMODL_PROJECT_SOURCE_DIR}/docs/Doxyfile)

# =============================================================================
# Memory checker options and add tests
# =============================================================================
find_program(MEMORYCHECK_COMMAND valgrind)
set(MEMORYCHECK_COMMAND_OPTIONS
    "--trace-children=yes \
                                 --leak-check=full \
                                 --track-origins=yes \
                                 --show-possibly-lost=no")
# do not enable tests if nmodl is used as submodule
if(NOT NMODL_AS_SUBPROJECT)
  include(CTest)
  add_subdirectory(test/unit)
  add_subdirectory(test/integration)
endif()

# =============================================================================
# list of autogenerated files
# =============================================================================
include(${PROJECT_SOURCE_DIR}/src/language/code_generator.cmake)

add_subdirectory(src)

# =============================================================================
# Prepare units database file from nrnunits.lib.in
# =============================================================================
if(NMODL_ENABLE_LEGACY_UNITS)
  set(LegacyY "")
  set(LegacyN "/")
else()
  set(LegacyY "/")
  set(LegacyN "")
endif()
configure_file(share/nrnunits.lib.in ${CMAKE_CURRENT_BINARY_DIR}/share/nmodl/nrnunits.lib @ONLY)

# =============================================================================
# Install unit database to share
# =============================================================================
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/nmodl/nrnunits.lib
        DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}share/nmodl)

# to print compiler flags in the build status
if(CMAKE_BUILD_TYPE)
  string(TOUPPER ${CMAKE_BUILD_TYPE} BUILD_TYPE_UPPER)
  set(COMPILER_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${BUILD_TYPE_UPPER}}")
else()
  set(COMPILER_FLAGS "${CMAKE_CXX_FLAGS}")
endif()
string(JOIN " " COMPILER_FLAGS "${COMPILER_FLAGS}" ${NMODL_EXTRA_CXX_FLAGS})

# =============================================================================
# Build status
# =============================================================================
message(STATUS "")
message(STATUS "Configured NMODL ${PROJECT_VERSION} (${NMODL_GIT_REVISION})")
message(STATUS "")
message(STATUS "You can now build NMODL using:")
message(STATUS "  cmake --build . --parallel 8 [--target TARGET]")
message(STATUS "You might want to adjust the number of parallel build jobs for your system.")
message(STATUS "Some non-default targets you might want to build:")
message(STATUS "--------------------+--------------------------------------------------------")
message(STATUS " Target             |   Description")
message(STATUS "--------------------+--------------------------------------------------------")
message(STATUS "test                | Run unit tests")
message(STATUS "install             | Will install NMODL to: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "--------------------+--------------------------------------------------------")
message(STATUS " Build option       | Status")

=== requirements.txt ===
Jinja2>=2.9.3
PyYAML>=3.13
pytest
pytest-cov
sympy
numpy

=== src/codegen/CMakeLists.txt ===
# =============================================================================
# Codegen library
# =============================================================================
add_library(
  codegen STATIC
  codegen_acc_visitor.cpp
  codegen_transform_visitor.cpp
  codegen_cpp_visitor.cpp
  codegen_compatibility_visitor.cpp
  codegen_helper_visitor.cpp
  codegen_info.cpp
  codegen_utils.cpp)
add_dependencies(codegen lexer util visitor)
target_link_libraries(codegen PRIVATE util)

# copy to build directory to make usable from build directory
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fast_math.hpp
               ${CMAKE_BINARY_DIR}/include/nmodl/fast_math.hpp COPYONLY)

=== src/printer/CMakeLists.txt ===
# =============================================================================
# Printer library
# =============================================================================
add_library(printer OBJECT code_printer.cpp json_printer.cpp nmodl_printer.cpp)
set_property(TARGET printer PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(printer PRIVATE util)

=== src/pybind/CMakeLists.txt ===
# =============================================================================
# pybind targets
# =============================================================================
set_source_files_properties(${PYBIND_GENERATED_SOURCES} PROPERTIES GENERATED TRUE)

# Set -fno-var-tracking-assignments on pyast.cpp with GCC to avoid a warning + double compilation
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
  foreach(pybind_file "${PROJECT_BINARY_DIR}/src/pybind/pyast.cpp")
    get_source_file_property(pybind_file_compile_options "${pybind_file}" COMPILE_OPTIONS)
    if("${pybind_file_compile_options}" STREQUAL "NOTFOUND")
      set(pybind_file_compile_options)
    endif()
    list(APPEND pybind_file_compile_options "-fno-var-tracking-assignments")
    set_source_files_properties("${pybind_file}" PROPERTIES COMPILE_OPTIONS
                                                            "${pybind_file_compile_options}")
  endforeach()
endif()

# build nmodl python module under lib/nmodl
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib/nmodl)

foreach(file ast.py dsl.py ode.py symtab.py visitor.py __init__.py)
  list(APPEND NMODL_PYTHON_FILES_IN ${NMODL_PROJECT_SOURCE_DIR}/nmodl/${file})
  list(APPEND NMODL_PYTHON_FILES_OUT ${PROJECT_BINARY_DIR}/lib/nmodl/${file})
endforeach()

add_library(pyembed pyembed.cpp)
set_property(TARGET pyembed PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(pyembed PRIVATE util)

if(NOT LINK_AGAINST_PYTHON)
  add_library(pywrapper SHARED ${CMAKE_CURRENT_SOURCE_DIR}/wrapper.cpp)
  set_target_properties(pywrapper PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
else()
  add_library(pywrapper ${CMAKE_CURRENT_SOURCE_DIR}/wrapper.cpp)
  set_property(TARGET pywrapper PROPERTY POSITION_INDEPENDENT_CODE ON)
  target_compile_definitions(pyembed PRIVATE NMODL_STATIC_PYWRAPPER=1)
endif()

target_include_directories(pyembed PRIVATE ${PYBIND11_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS})
target_include_directories(pywrapper PRIVATE ${pybind11_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})

# ~~~
# pybind11::embed adds PYTHON_LIBRARIES to target_link_libraries. To avoid link to
# libpython, we can use `module` interface library from pybind11.
# ~~~
if(NOT LINK_AGAINST_PYTHON)
  target_link_libraries(pywrapper PRIVATE pybind11::module)
else()
  target_link_libraries(pywrapper PRIVATE pybind11::embed)
endif()

# avoid _nmodl target if python bindings are disabled
if(NMODL_ENABLE_PYTHON_BINDINGS)
  # ~~~
  # Note that LTO causes link time errors with GCC 8. To avoid this, we disable LTO
  # for pybind using NO_EXTRAS. See #266.
  # ~~~
  pybind11_add_module(
    _nmodl NO_EXTRAS ${NMODL_PROJECT_SOURCE_DIR}/src/ast/ast_common.hpp
    ${NMODL_PROJECT_SOURCE_DIR}/src/pybind/pybind_utils.hpp
    ${NMODL_PROJECT_SOURCE_DIR}/src/pybind/pynmodl.cpp ${PYBIND_GENERATED_SOURCES})
  add_dependencies(_nmodl lexer pyastgen util)
  target_link_libraries(_nmodl PRIVATE printer symtab visitor pyembed)

  # in case of wheel, python module shouldn't link to wrapper library
  if(LINK_AGAINST_PYTHON)
    target_link_libraries(_nmodl PRIVATE pywrapper)
  endif()

  add_custom_command(
    OUTPUT ${PROJECT_BINARY_DIR}/lib/nmodl
    COMMAND ${CMAKE_COMMAND} -E copy_if_different $<TARGET_FILE:_nmodl> ${PROJECT_BINARY_DIR}/nmodl
    DEPENDS ${NMODL_PYTHON_FILES_IN} _nmodl
    COMMENT "-- COPYING NMODL PYTHON MODULE --")
endif()

add_custom_target(copy_python_files ALL DEPENDS ${NMODL_PYTHON_FILES_OUT})
add_custom_command(
  OUTPUT ${NMODL_PYTHON_FILES_OUT}
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${NMODL_PROJECT_SOURCE_DIR}/nmodl
          ${PROJECT_BINARY_DIR}/lib/nmodl
  DEPENDS ${NMODL_PYTHON_FILES_IN}
  COMMENT "-- COPYING NMODL PYTHON FILES --")

# =============================================================================
# Copy python binding components and examples into build directory
# =============================================================================
file(GLOB NMODL_PYTHON_HELPER_FILES "${NMODL_PROJECT_SOURCE_DIR}/nmodl/*.py")
file(COPY ${NMODL_PYTHON_HELPER_FILES} DESTINATION ${CMAKE_BINARY_DIR}/lib/nmodl/)
file(COPY ${NMODL_PROJECT_SOURCE_DIR}/nmodl/ext DESTINATION ${CMAKE_BINARY_DIR}/lib/nmodl/)

# =============================================================================
# Install python binding components
# =============================================================================
# ~~~
# scikit already installs the package in /nmodl. If we add it another time
# things are installed twice with the wheel and in weird places. Let's just
# move the .so libs
# ~~~
if(NOT LINK_AGAINST_PYTHON)
  install(TARGETS pywrapper DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}lib)
  if(NMODL_ENABLE_PYTHON_BINDINGS)
    install(TARGETS _nmodl DESTINATION nmodl/)
  endif()
elseif(SKBUILD)
  # skbuild needs the installation dir to be in nmodl to do the correct inplace
  install(
    DIRECTORY ${CMAKE_BINARY_DIR}/lib/nmodl
    DESTINATION .
    PATTERN "__pycache__" EXCLUDE)
else()
  install(
    DIRECTORY ${CMAKE_BINARY_DIR}/lib/
    DESTINATION lib
    PATTERN "__pycache__" EXCLUDE)
endif()

=== src/utils/CMakeLists.txt ===
# =============================================================================
# Utility library
# =============================================================================
add_library(
  util STATIC
  common_utils.cpp
  file_library.cpp
  logger.cpp
  perf_stat.cpp
  string_utils.cpp
  table_data.cpp
  ${PROJECT_BINARY_DIR}/src/config/config.cpp)
set_property(TARGET util PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(util PUBLIC fmt::fmt nlohmann_json::nlohmann_json spdlog::spdlog_header_only)

=== src/visitors/CMakeLists.txt ===
# =============================================================================
# Visitor sources
# =============================================================================
set_source_files_properties(${VISITORS_GENERATED_SOURCES} PROPERTIES GENERATED TRUE)

# =============================================================================
# Visitor library and executable
# =============================================================================
include_directories(${PYBIND11_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS})
add_library(
  visitor STATIC
  after_cvode_to_cnexp_visitor.cpp
  constant_folder_visitor.cpp
  defuse_analyze_visitor.cpp
  global_var_visitor.cpp
  implicit_argument_visitor.cpp
  indexedname_visitor.cpp
  inline_visitor.cpp
  kinetic_block_visitor.cpp
  local_to_assigned_visitor.cpp
  local_var_rename_visitor.cpp
  localize_visitor.cpp
  loop_unroll_visitor.cpp
  neuron_solve_visitor.cpp
  perf_visitor.cpp
  rename_visitor.cpp
  semantic_analysis_visitor.cpp
  solve_block_visitor.cpp
  steadystate_visitor.cpp
  sympy_conductance_visitor.cpp
  sympy_replace_solutions_visitor.cpp
  sympy_solver_visitor.cpp
  units_visitor.cpp
  var_usage_visitor.cpp
  verbatim_var_rename_visitor.cpp
  verbatim_visitor.cpp
  visitor_utils.cpp
  ${VISITORS_GENERATED_SOURCES})
set_property(TARGET visitor PROPERTY POSITION_INDEPENDENT_CODE ON)
add_dependencies(visitor pywrapper)
target_link_libraries(visitor PUBLIC lexer util)

# ~~~
# pybind11::embed adds PYTHON_LIBRARIES to target_link_libraries. To avoid link to
# libpython, we can use `pybind11::module` interface library from pybind11.
# ~~~
if(NOT LINK_AGAINST_PYTHON)
  target_link_libraries(visitor PRIVATE pybind11::module)
else()
  target_link_libraries(visitor PRIVATE pybind11::embed)
endif()

if(NOT NMODL_AS_SUBPROJECT)
  add_executable(nmodl_visitor main.cpp)

  target_link_libraries(
    nmodl_visitor
    CLI11::CLI11
    printer
    visitor
    symtab
    util
    lexer
    ${NMODL_WRAPPER_LIBS})
endif()

# =============================================================================
# Install executable
# =============================================================================
if(NOT NMODL_AS_SUBPROJECT)
  install(
    TARGETS nmodl_visitor
    DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin/visitor
    CONFIGURATIONS Debug)
endif()

=== test/unit/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

# =============================================================================
# Add extra compile flags to NMODL test sources
# =============================================================================
add_compile_options(${NMODL_EXTRA_CXX_FLAGS})
add_link_options(${NMODL_EXTRA_CXX_FLAGS})
add_compile_options(${NMODL_TESTS_COMPILER_WARNING_SUPPRESSIONS})

include_directories(${PYBIND11_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS})
include_directories(${NMODL_PROJECT_SOURCE_DIR}/test)
include_directories(${NMODL_PROJECT_SOURCE_DIR}/src/solver)
include_directories(${NMODL_PROJECT_SOURCE_DIR}/src/utils)
include_directories(${NMODL_PROJECT_SOURCE_DIR}/ext/eigen)

# =============================================================================
# Common input data library
# =============================================================================
add_library(test_util STATIC utils/nmodl_constructs.cpp utils/test_utils.cpp)
target_link_libraries(test_util PUBLIC spdlog::spdlog_header_only)

# =============================================================================
# Common input data library
# =============================================================================
add_library(config STATIC ${PROJECT_BINARY_DIR}/src/config/config.cpp)

# =============================================================================
# Test executables
# =============================================================================
add_executable(testmodtoken modtoken/modtoken.cpp)
add_executable(testlexer lexer/tokens.cpp)
add_executable(testparser parser/parser.cpp)
add_executable(
  testvisitor
  visitor/main.cpp
  visitor/after_cvode_to_cnexp.cpp
  visitor/constant_folder.cpp
  visitor/defuse_analyze.cpp
  visitor/global_to_range.cpp
  visitor/implicit_argument.cpp
  visitor/inline.cpp
  visitor/json.cpp
  visitor/kinetic_block.cpp
  visitor/localize.cpp
  visitor/local_to_assigned.cpp
  visitor/lookup.cpp
  visitor/loop_unroll.cpp
  visitor/misc.cpp
  visitor/neuron_solve.cpp
  visitor/nmodl.cpp
  visitor/perf.cpp
  visitor/rename.cpp
  visitor/semantic_analysis.cpp
  visitor/solve_block.cpp
  visitor/steadystate.cpp
  visitor/sympy_conductance.cpp
  visitor/sympy_solver.cpp
  visitor/units.cpp
  visitor/var_usage.cpp
  visitor/verbatim.cpp
  visitor/node_index.cpp)
add_executable(testprinter printer/printer.cpp)
add_executable(testsymtab symtab/symbol_table.cpp)
add_executable(testnewton newton/newton.cpp ${NEWTON_SOLVER_SOURCE_FILES})
add_executable(testcrout crout/crout.cpp ${CROUT_SOLVER_SOURCE_FILES})
add_executable(testfast_math fast_math/fast_math.cpp ${NEWTON_SOLVER_SOURCE_FILES})
add_executable(testunitlexer units/lexer.cpp)
add_executable(testunitparser units/parser.cpp)
add_executable(
  testcodegen
  codegen/main.cpp codegen/codegen_helper.cpp codegen/codegen_utils.cpp
  codegen/codegen_cpp_visitor.cpp codegen/transform.cpp codegen/codegen_compatibility_visitor.cpp)

target_link_libraries(testmodtoken lexer util)
target_link_libraries(testlexer lexer util)
target_link_libraries(
  testparser
  visitor
  symtab
  lexer
  util
  test_util
  printer
  ${NMODL_WRAPPER_LIBS})
target_link_libraries(
  testvisitor
  visitor
  symtab
  lexer
  util
  test_util
  printer
  codegen
  ${NMODL_WRAPPER_LIBS})
target_link_libraries(
  testcodegen
  codegen
  visitor
  symtab
  lexer
  util
  test_util
  printer
  ${NMODL_WRAPPER_LIBS})
target_link_libraries(testprinter printer util)
target_link_libraries(testsymtab symtab lexer util)
target_link_libraries(testunitlexer lexer util)
target_link_libraries(testunitparser lexer test_util config)

# =============================================================================
# Use catch_discover instead of add_test for granular test result reporting.
# =============================================================================
set(test_env ${NMODL_SANITIZER_ENABLE_ENVIRONMENT})
set(testvisitor_env "PYTHONPATH=${PROJECT_BINARY_DIR}/lib:$ENV{PYTHONPATH}")
if(NOT LINK_AGAINST_PYTHON)
  list(APPEND testvisitor_env "NMODL_PYLIB=$ENV{NMODL_PYLIB}")
  list(APPEND testvisitor_env
       "NMODL_WRAPLIB=${PROJECT_BINARY_DIR}/lib/nmodl/libpywrapper${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()

foreach(
  test_name
  testcodegen
  testmodtoken
  testlexer
  testparser
  testvisitor
  testprinter
  testsymtab
  testnewton
  testcrout
  testfast_math
  testunitlexer
  testunitparser)

  target_link_libraries(${test_name} Catch2::Catch2)
  cpp_cc_configure_sanitizers(TARGET ${test_name})
  set(env ${test_env})
  list(APPEND env ${${test_name}_env})
  # See https://github.com/catchorg/Catch2/issues/2424
  string(REPLACE ";" ";ENVIRONMENT;" _environment_vars_list "${env}")
  # Catch2 doesn't set these environment variables when running the executable to discover tests
  # (https://github.com/catchorg/Catch2/issues/1810). This means that in builds that enable it, we
  # see errors from the LeakSanitizer during the build. These seem to be harmless because Catch2
  # does not seem to check the exit code.
  catch_discover_tests(${test_name} TEST_PREFIX "${test_name}/" PROPERTIES ENVIRONMENT
                       "${_environment_vars_list}")
endforeach()

# =============================================================================
# pybind11 tests
# =============================================================================
add_test(NAME Ode COMMAND ${PYTHON_EXECUTABLE} -m pytest ${NMODL_PROJECT_SOURCE_DIR}/test/unit/ode)
set_tests_properties(Ode PROPERTIES ENVIRONMENT
                                    PYTHONPATH=${PROJECT_BINARY_DIR}/lib:$ENV{PYTHONPATH})

if(NMODL_ENABLE_PYTHON_BINDINGS)
  add_test(NAME Pybind COMMAND ${PYTHON_EXECUTABLE} -m pytest
                               ${NMODL_PROJECT_SOURCE_DIR}/test/unit/pybind)
  set_tests_properties(Pybind PROPERTIES ENVIRONMENT
                                         PYTHONPATH=${PROJECT_BINARY_DIR}/lib:$ENV{PYTHONPATH})
  cpp_cc_configure_sanitizers(TEST Pybind PRELOAD)
endif()

=== debian/changelog ===
nmodl (0.6-3) unstable; urgency=medium

  * Team Upload.
  * Use canonical name for team
  * Use dh-sequence-python3

 -- Alexandre Detiste <tchet@debian.org>  Sat, 02 Aug 2025 15:55:48 +0200

nmodl (0.6-2) unstable; urgency=medium

  * Team Upload.
  * Drop d/p/05_src-config-config.cpp.in-Drop-build-path-from-NRNUNI.patch
    + Causes the package to FTBFS

 -- Nilesh Patra <nilesh@debian.org>  Sat, 27 Jan 2024 22:59:00 +0530

nmodl (0.6-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 0.6
  * Backport upstream patch and add few more changes to fixup
    catchv2_3 compatibility (Closes: #1054683)
  * Enable Build-Time tests
  * Add d/salsa-ci.yml
  * Add patch to fix FTBFS with 32 bit archs
  * Do not run tests in parallel to help prevent race condition based failures
  * Add patch to make build reproducible
    + Thanks to Vagrant Cascadian for the patch (Closes: #1034327)
  * Add d/clean to clean off __pycache__ (Closes: #1047577)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 27 Jan 2024 20:54:26 +0530

=== debian/control ===
Source: nmodl
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: bison,
               bluebrain-hpc-coding-conventions,
               catch2,
               chrpath,
               cmake,
               debhelper-compat (= 13),
               dh-sequence-python3,
               flex,
               libcli11-dev,
               libeigen3-dev,
               libfl-dev,
               libfmt-dev,
               libpython3-dev,
               libspdlog-dev,
               nlohmann-json3-dev,
               pybind11-dev,
               python3-jinja2,
               python3-pkg-resources,
               python3-pytest,
               python3-sympy,
               python3-yaml,
               python3:any
Standards-Version: 4.7.2
Rules-Requires-Root: no
X-Python3-Version: >= 3.11
Homepage: https://github.com/BlueBrain/nmodl
Vcs-Git: https://salsa.debian.org/science-team/nmodl.git
Vcs-Browser: https://salsa.debian.org/science-team/nmodl

Package: nmodl
Architecture: any
Depends: python3-nmodl (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Code generation engine for the NEURON modeling language
 The NMODL Framework is a code generation engine for the
 NEURON MODeling Language (NMODL).
 It is designed with modern compiler and code generation techniques to:
   * Provide modular tools for parsing, analysing and transforming NMODL
   * Provide easy to use, high level Python API
   * Generate optimised code for modern compute architectures
     including CPUs, GPUs
   * Flexibility to implement new simulator backends
   * Support the full NMODL specification

Package: python3-nmodl
Architecture: any
Section: python
Depends: python3-jinja2,
         python3-pkg-resources,
         python3-sympy,
         python3-yaml,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: nmodl
Description: Python support for the NEURON modeling language engine
 The NMODL Framework is a code generation engine for the
 NEURON MODeling Language (NMODL).
 .
 This package contains support for using nmodl from Python.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

BUILD_FLAGS = \
	-DCMAKE_INSTALL_RPATH="" \
	-DNMODL_3RDPARTY_USE_CATCH2:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_CLI11:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_EIGEN:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_FMT:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_JSON:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_PYBIND11:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_SPDLOG:BOOL=OFF

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_FLAGS)

override_dh_auto_test:
	dh_auto_test --no-parallel

override_dh_auto_install:
	dh_auto_install
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/nmodl

=== debian/tests/control ===
Tests: simple
Depends: build-essential,
         python3-nmodl
Restrictions: superficial

=== debian/watch ===
version=4

https://github.com/BlueBrain/nmodl/tags .*/@ANY_VERSION@\.tar\.gz
